import { NodeTypeToken } from '../model/graph.mjs';
import { GraphLink } from '../model/link.mjs';
import { GraphNode } from '../model/node.mjs';
/**
 * Link filter.
 * Receives a link and returns whether the link should be included or not.
 */
export type LinkFilter<T extends NodeTypeToken, Node extends GraphNode<T>, Link extends GraphLink<T, Node>> = (link: Link) => boolean;
